onEvent('recipes', e => {

  e.shapeless('3x minecraft:oak_planks', ['minecraft:cactus'])
  e.shapeless('3x minecraft:blaze_powder', ['minecraft:blaze_rod'])
  e.shapeless('9x pneumaticcraft:ingot_iron_compressed', ['pneumaticcraft:compressed_iron_block'])
  e.remove({ output: 'minecraft:blaze_powder' })
  e.remove({ output: 'minecraft:bucket' })
  e.remove({ output: 'minecraft:furnace' })
  e.remove({ output: 'masterfulmachinery:projector' })
  e.remove({ output: 'masterfulmachinery:structure_generator' })
  e.remove({ output: 'masterfulmachinery:structure_gen_device' })
  e.remove({ output: 'weirdinggadget:weirding_gadget' })
  e.remove({ output: 'evilcraft:mace_of_destruction' })
  e.remove({ output: 'buildinggadgets:gadget_destruction' })
  e.remove({ output: 'cyclic:emerald_leggings' })
  e.remove({ output: 'cyclic:crystal_leggings' })
  e.remove({ output: '#chiselsandbits:chisel' })
  e.remove({ output: 'chiselsandbits:quill' })
  e.remove({ output: 'chiselsandbits:chiseled_printer' })
  e.remove({ output: 'chiselsandbits:bit_storage' })
  e.remove({ output: '#chiselsandbits:bit_bag' })
  e.remove({ output: 'evilcraft:sceptre_of_thunder' })
  e.remove({ output: 'thermal:chiller_ingot_cast' })
  e.remove({ output: '#projectred-exploration:backpacks' })
  e.remove({ output: 'energycontrol:basic_circuit' })
  e.remove({ output: 'energycontrol:advanced_circuit' })
  e.remove({ output: 'energycontrol:kit_assembler' })
  e.remove({ output: 'minecraft:hopper' })
  e.remove({ output: '#excompressum:heavy_sieve' })
  e.remove({ output: 'excompressum:auto_heavy_sieve' })
  e.remove({ output: 'appliedenergistics2:fluix_pearl' })
  e.remove({ output: 'thermal:quartz_gear' })
  e.remove({ output: '#forge:gears', type: 'minecraft:crafting_shaped'})
  e.remove({ output: 'tconstruct:crafting_station'})
  e.remove({ output:'botania:terraform_rod'})
  e.remove({ output:'botania:exchange_rod'})
  e.remove({ output:'cyclic:build_scepter'})
  e.remove({ output:'cyclic:replace_scepter'})
  e.remove({ output:'cyclic:offset_scepter'})
  e.remove({ output:'tconstruct:efln_ball'})
  e.remove({ output:'botania:smelt_rod'})
  e.remove({ output:'botania:divining_rod'})
  e.remove({ output:'botania:fire_rod'})
  e.remove({ output:'botania:dirt_rod'})
  e.remove({ output:'botania:skydirt_rod'})
  e.remove({ output:'botania:cobble_rod'})
  e.remove({ output:'botania:water_rod'})
  e.remove({ output:'botania:tornado_rod'})
  e.remove({ output:'botania:fire_rod'})
  e.remove({ output:'botania:missile_rod'})
  e.remove({ output:'cyclic:magic_net'})
  e.remove({ output:'cyclic:tile_transporter_empty'})
  e.remove({ output:'cyclic:apple_ender'})
  e.remove({ output:'cyclic:randomize_scepter'})
  e.remove({ output:'industrialforegoing:simple_black_hole_unit'})
  e.remove({ output:'industrialforegoing:advanced_black_hole_unit'})
  e.remove({ output:'industrialforegoing:supreme_black_hole_unit'})
  e.remove({ output:'lazierae2:universal_press'})
  e.remove({ output:'exnihilosequentia:crimson_crucible'})
  e.remove({ output:'exnihilosequentia:warped_crucible'})
  e.remove({ output: 'extendedcrafting:ultimate_singularity' })

  e.shaped('energycontrol:machine_casing', [
    '313',
    '121',
    '313'
  ], {
    1: 'minecraft:quartz_block', 2: 'kubejs:basicframe', 3: 'mekanism:block_steel'
  })


  e.shaped('ceramics:clay_bucket', [
    ' 1',
    ' 2',
    ' 1'
  ], {
    1: 'minecraft:blaze_powder', 2: 'ceramics:unfired_clay_bucket'
  })

  e.shaped('8x astralsorcery:marble_raw', [
    '333',
    '121',
    '444'
  ], {
    1: 'botania:blaze_block', 2: 'minecraft:cobblestone', 3: 'minecraft:andesite', 4: 'minecraft:granite'
  })

  e.shaped('torchmaster:megatorch', [
    '131',
    '121',
    '111'
  ], {
    1: 'botania:blaze_block', 2: 'botania:ender_eye_block', 3: 'minecraft:torch'
  })

  e.shaped('torchmaster:feral_flare_lantern', [
    '131',
    '121',
    '111'
  ], {
    1: 'botania:blaze_block', 2: 'botania:ender_eye_block', 3: 'torchmaster:megatorch'
  })

  e.shaped('xnet:controller', [
    '131',
    '424',
    '131'
  ], {
    1: 'thermal:redstone_servo',  2: 'thermal:tinker_bench', 3: 'thermal:charge_bench', 4: 'thermal:rf_coil'
  })

  e.shaped('4x xnet:facade', [
    '434',
    '323',
    '131'
  ], {
    1: 'thermal:redstone_servo',  2: 'thermal:device_rock_gen', 3: 'thermal:signalum_glass', 4: 'thermal:rf_coil'
  })

  e.shaped('xnet:router', [
    '141',
    '232',
    '141'
  ], {
    1: 'thermal:redstone_servo',  2: Item.of('thermal:energy_cell', '{Damage:0,BlockEntityTag:{EnergyMax:1000000,EnergySend:1000,Energy:0,EnergyRecv:1000},AS_Amulet_Holder:[I;663829937,1417103856,-1116651025,182012991]}'), 3: 'thermal:device_water_gen', 4: 'thermal:rf_coil'
  })

  e.shaped('xnet:wireless_router', [
    '121',
    '434',
    '121'
  ], {
    1: 'thermal:redstone_servo',  2: 'thermal:upgrade_augment_2', 3: Item.of('thermal:energy_cell', '{Damage:0,BlockEntityTag:{EnergyMax:1000000,EnergySend:1000,Energy:0,EnergyRecv:1000},AS_Amulet_Holder:[I;663829937,1417103856,-1116651025,182012991]}'), 4: 'thermal:rf_coil'
  })

  e.shaped('xnet:antenna_base', [
    '121',
    '434',
    '141'
  ], {
    1: 'thermal:redstone_servo',  2: 'thermal:redprint', 3: 'thermal:netherite_plate', 4: 'thermal:rf_coil'
  })

  e.shaped('xnet:antenna', [
    '131',
    '424',
    '131'
  ], {
    1: 'thermal:redstone_servo',  2: 'thermal:upgrade_augment_1', 3: 'thermal:netherite_plate', 4: 'thermal:rf_coil'
  })

  e.shaped('xnet:antenna_dish', [
    '313',
    '424',
    '313'
  ], {
    1: 'thermal:redstone_servo',  2: 'thermal:upgrade_augment_2', 3: 'thermal:netherite_plate', 4: 'thermal:rf_coil'
  })

  e.shaped('xnet:redstone_proxy_upd', [
    '131',
    '424',
    '131'
  ], {
    1: 'thermal:signalum_plate',  2: 'thermal:upgrade_augment_2', 3: 'thermal:netherite_plate', 4: 'thermal:rf_coil'
  })
  e.shaped('4x xnet:netcable_routing', [
    '141',
    '323',
    '131'
  ], {
    1: 'minecraft:string',  2: 'minecraft:gold_nugget', 3: 'minecraft:redstone', 4: 'minecraft:black_dye'
  })

  e.shaped('4x xnet:netcable_yellow', [
    '141',
    '323',
    '131'
  ], {
    1: 'minecraft:string',  2: 'minecraft:gold_nugget', 3: 'minecraft:redstone', 4: 'minecraft:yellow_dye'
  })

  e.shaped('4x xnet:netcable_green', [
    '141',
    '323',
    '131'
  ], {
    1: 'minecraft:string',  2: 'minecraft:gold_nugget', 3: 'minecraft:redstone', 4: 'minecraft:green_dye'
  })

  e.shaped('4x xnet:netcable_red', [
    '141',
    '323',
    '131'
  ], {
    1: 'minecraft:string',  2: 'minecraft:gold_nugget', 3: 'minecraft:redstone', 4: 'minecraft:red_dye'
  })

  e.shaped('4x xnet:netcable_blue', [
    '141',
    '323',
    '131'
  ], {
    1: 'minecraft:string',  2: 'minecraft:gold_nugget', 3: 'minecraft:redstone', 4: 'minecraft:blue_dye'
  })

  e.shaped('2x xnet:connector_red', [
    '141',
    '323',
    '131'
  ], {
    1: 'minecraft:chest', 2: 'thermal:signalum_plate', 3: 'minecraft:redstone', 4: 'minecraft:red_dye'
  })

  e.shaped('2x xnet:connector_green', [
    '141',
    '323',
    '131'
  ], {
    1: 'minecraft:chest',  2: 'thermal:signalum_plate', 3: 'minecraft:redstone', 4: 'minecraft:green_dye'
  })

  e.shaped('2x xnet:connector_yellow', [
    '141',
    '323',
    '131'
  ], {
    1: 'minecraft:chest',  2: 'thermal:signalum_plate', 3: 'minecraft:redstone', 4: 'minecraft:yellow_dye'
  })

  e.shaped('2x xnet:connector_blue', [
    '141',
    '323',
    '131'
  ], {
    1: 'minecraft:chest',  2: 'thermal:signalum_plate', 3: 'minecraft:redstone', 4: 'minecraft:blue_dye'
  })

  e.shaped('2x xnet:connector_routing', [
    '141',
    '323',
    '131'
  ], {
    1: 'minecraft:chest',  2: 'thermal:netherite_plate', 3: 'minecraft:redstone', 4: 'minecraft:black_dye'
  })

  e.shaped('tconstruct:crafting_station', [
    '111',
    '212',
    '2 2'
  ], {
    1: '#minecraft:planks',  2: 'minecraft:stick'
  })

  e.smelting('astralsorcery:starmetal_ingot', 'astralsorcery:stardust')

  e.shaped('xnet:advanced_connector_green', [
    '141',
    '323',
    '141'
  ], {
    1: 'xnet:connector_green',  2: 'thermal:netherite_plate', 3: 'thermal:rf_coil', 4: 'minecraft:green_dye'
  })

  e.shaped('xnet:advanced_connector_red', [
    '141',
    '323',
    '141'
  ], {
    1: 'xnet:connector_red',  2: 'thermal:netherite_plate', 3: 'thermal:rf_coil', 4: 'minecraft:red_dye'
  })

  e.shaped('xnet:advanced_connector_blue', [
    '141',
    '323',
    '141'
  ], {
    1: 'xnet:connector_blue',  2: 'thermal:netherite_plate', 3: 'thermal:rf_coil', 4: 'minecraft:blue_dye'
  })

  e.shaped('xnet:advanced_connector_yellow', [
    '141',
    '323',
    '141'
  ], {
    1: 'xnet:connector_yellow',  2: 'thermal:netherite_plate', 3: 'thermal:rf_coil', 4: 'minecraft:yellow_dye'
  })

  e.shaped('xnet:advanced_connector_routing', [
    '141',
    '323',
    '141'
  ], {
    1: 'xnet:connector_routing',  2: 'thermal:netherite_plate', 3: 'thermal:rf_coil', 4: 'minecraft:black_dye'
  })

  e.shaped('xnet:connector_upgrade', [
    '162',
    '656',
    '364'
  ], {
    1: 'xnet:netcable_yellow',  2: 'xnet:netcable_blue', 3: 'xnet:netcable_red', 4: 'xnet:netcable_green', 5: 'thermal:redstone_servo', 6: 'minecraft:redstone'
  })

  e.shaped('4x storagenetwork:kabel', [
    '   ',
    '123',
    '   '
  ], {
    1: 'immersiveengineering:wirecoil_electrum',  2: 'immersiveengineering:wirecoil_copper', 3: 'immersiveengineering:wirecoil_steel'
  })

  e.shaped('appliedenergistics2:interface', [
    '   ',
    '1  ',
    '   '
  ], {
    1: 'appliedenergistics2:cable_interface'
  })

  e.shaped('2x storagenetwork:storage_kabel', [
    '   ',
    '12 ',
    '   '
  ], {
    1: 'storagenetwork:kabel',  2: 'immersiveengineering:wirecoil_redstone'
  })

  e.shaped('2x storagenetwork:import_kabel', [
    '   ',
    '12 ',
    '   '
  ], {
    1: 'storagenetwork:kabel',  2: 'immersiveengineering:wirecoil_electrum_ins'
  })

  e.shaped('2x storagenetwork:import_filter_kabel', [
    '   ',
    '123',
    '   '
  ], {
    1: 'storagenetwork:kabel',  2: 'immersiveengineering:wirecoil_copper', 3: 'immersiveengineering:wirecoil_steel'
  })

  e.shaped('2x storagenetwork:filter_kabel', [
    '   ',
    '123',
    '   '
  ], {
    1: 'storagenetwork:kabel',  2: 'immersiveengineering:wirecoil_electrum_ins', 3: 'immersiveengineering:wirecoil_steel'
  })

  e.shaped('2x storagenetwork:export_kabel', [
    '   ',
    '123',
    '   '
  ], {
    1: 'storagenetwork:kabel',  2: 'immersiveengineering:wirecoil_copper', 3: 'immersiveengineering:wirecoil_electrum_ins'
  })

  e.shaped('lazierae2:universal_press', [
    '   ',
    '141',
    '232'
  ], {
    1: 'extendedcrafting:crystaltine_catalyst',  2: 'extendedcrafting:redstone_catalyst', 3: 'ae2extras:256k_cell_component', 4: 'appliedenergistics2:singularity'
  })

  e.shaped('exnihilosequentia:warped_crucible', [
    '1 1',
    '141',
    '2 2'
  ], {
    1: 'botania:blaze_block',  2: 'minecraft:stick', 4: 'minecraft:crimson_slab'
  })

  e.shaped('exnihilosequentia:crimson_crucible', [
    '1 1',
    '141',
    '2 2'
  ], {
    1: 'botania:blaze_block',  2: 'minecraft:stick', 4: 'minecraft:crimson_slab'
  })

  e.shaped('chisel:marble/raw', [
    '   ',
    '12 ',
    '21 '
  ], {
    1: 'minecraft:diorite',  2: 'minecraft:stone',
  })

  e.shaped('chisel:basalt/raw', [
    '   ',
    '12 ',
    '21 '
  ], {
    1: 'chisel:marble/raw',  2: 'minecraft:stone',
  })

  e.shaped('kubejs:enderpearlblock', [
    '   ',
    '11 ',
    '11 '
  ], {
    1: 'minecraft:ender_pearl',
  })

  e.shaped('fluxnetworks:flux_dust', [
    '111',
    '121',
    '111'
  ], {
    1: 'minecraft:redstone', 2: 'minecraft:obsidian'

  })

  e.shaped('excompressum:auto_heavy_sieve', [
    '131',
    '323',
    '434'
  ], {
    1: 'mekanism:block_steel', 2: 'exnihilosequentia:mesh_netherite', 3:'minecraft:glass_pane', 4:'mekanism:ingot_steel'

  })
})